:
eval 'exec perl -w -S $0 ${1+"$@"}'
 if 0;
#
#         name: callTP.pl (Chapter 5)
#      version: Oct 23, 2002
#  description: Perl Interface to Theorem Provers
#      authors: Patrick Blackburn & Johan Bos
#        otter: http://www-unix.mcs.anl.gov/AR/otter/
#      bliksem: http://www.mpi-sb.mpg.de/~bliksem/
#      vampire: http://www.cs.man.ac.uk/~riazanoa/Vampire/

my $otter_selected = ($ARGV[0] =~ /otter/);
my $otter_result = 0;
my $readotter = 0;

my $bliksem_selected = ($ARGV[0] =~ /bliksem/);
my $bliksem_result = 0;
my $readbliksem = 0;


if ($otter_selected) {
   open(OTTER_OUTPUT, "otter < /tmp/otter.in 2>/dev/null |");
   $readotter=1;
}

if ($bliksem_selected) {
   open(BLIKSEM_OUTPUT, "bliksem < /tmp/bliksem.in 2>/dev/null |");
   $readbliksem=1;
}

while($readotter || $readbliksem) { 
  if ($readotter && defined($_ = <OTTER_OUTPUT>)) {
     if ($_ =~ /proof of the theorem/) {
        $otter_result = 1;
        $readotter = 0,
        $readbliksem = 0,
     }
  }
  else {
     $readotter=0;
  }
  if ($readbliksem && defined($_ = <BLIKSEM_OUTPUT>)) {
     if ($_ =~ /found a proof/) {
        $bliksem_result = 1;
        $readotter = 0,
        $readbliksem = 0;
     }
  }
  else {
     $readbliksem=0;
  }
}

if ($otter_selected) {
   close OTTER_OUTPUT;			 
}

if ($bliksem_selected) {
   close BLIKSEM_OUTPUT;			 
}

open(OUTPUT,">/tmp/tp.out");
if ($otter_result == 1) {
   print OUTPUT "proof.\n";
   print OUTPUT "engine(otter).\n";
}
elsif ($bliksem_result == 1) {
   print OUTPUT "proof.\n";
   print OUTPUT "engine(bliksem).\n";
}
else {
   print OUTPUT "unknown.\n";
}
close(OUTPUT);

exit 1;

