/*************************************************************************

         name: cnfTestSuite.pl
      version: Oct 26, 2002
  description: Testsuite with Propositional Formulas and known cnf forms
      authors: Patrick Blackburn & Johan Bos
 
*************************************************************************/

:- module(cnfTestSuite,[formulaClause/2]).


/*========================================================================
   Formulas and known cnf forms for them.
========================================================================*/

formulaClause(imp(p,q),[[not(p),q]]).

formulaClause(imp(and(p,imp(q,r)),s),[[s,not(p),q],[s,not(p),not(r)]]).

formulaClause(or(not(or(not(p),q)),or(not(r),p)),[[p,not(r)],[not(q),not(r),p]]).

formulaClause(imp(imp(not(p),q),imp(not(r),s)),[[not(p),r,s],[not(q),r,s]]).
